#ifndef __HUT_TELNET__
#define __HUT_TELNET__


#ifndef TELOPT_BINARY
# define TELOPT_BINARY	0
#endif
#ifndef TELOPT_ECHO
# define TELOPT_ECHO	1
#endif
#ifndef TELOPT_RCP
# define TELOPT_RCP	2
#endif
#ifndef TELOPT_SGA
# define TELOPT_SGA	3
#endif
#ifndef TELOPT_NAMS
# define TELOPT_NAMS	4
#endif
#ifndef TELOPT_STATUS
# define TELOPT_STATUS	5
#endif
#ifndef TELOPT_TM
# define TELOPT_TM	6
#endif
#ifndef TELOPT_RCTE
# define TELOPT_RCTE	7
#endif
#ifndef TELOPT_NAOL
# define TELOPT_NAOL 	8
#endif
#ifndef TELOPT_NAOP
# define TELOPT_NAOP 	9
#endif
#ifndef TELOPT_NAOCRD
# define TELOPT_NAOCRD	10
#endif
#ifndef TELOPT_NAOHTS
# define TELOPT_NAOHTS	11
#endif
#ifndef TELOPT_NAOHTD
# define TELOPT_NAOHTD	12
#endif
#ifndef TELOPT_NAOFFD
# define TELOPT_NAOFFD	13
#endif
#ifndef TELOPT_NAOVTS
# define TELOPT_NAOVTS	14
#endif
#ifndef TELOPT_NAOVTD
# define TELOPT_NAOVTD	15
#endif
#ifndef TELOPT_NAOLFD
# define TELOPT_NAOLFD	16
#endif
#ifndef TELOPT_XASCII
# define TELOPT_XASCII	17
#endif
#ifndef TELOPT_LOGOUT
# define TELOPT_LOGOUT	18
#endif
#ifndef TELOPT_BM
# define TELOPT_BM	19
#endif
#ifndef TELOPT_DET
# define TELOPT_DET	20
#endif
#ifndef TELOPT_SUPDUP
# define TELOPT_SUPDUP	21
#endif
#ifndef TELOPT_SUPDUPOUTPUT
# define TELOPT_SUPDUPOUTPUT 22
#endif
#ifndef TELOPT_SNDLOC
# define TELOPT_SNDLOC	23
#endif
#ifndef TELOPT_TTYPE
# define TELOPT_TTYPE	24
#endif
#ifndef TELOPT_EOR
# define TELOPT_EOR	25
#endif
#ifndef TELOPT_TUID
# define TELOPT_TUID	26
#endif
#ifndef TELOPT_OUTMRK
# define TELOPT_OUTMRK	27
#endif
#ifndef TELOPT_TTYLOC
# define TELOPT_TTYLOC	28
#endif
#ifndef TELOPT_3270REGIME
# define TELOPT_3270REGIME 29
#endif
#ifndef TELOPT_X3PAD
# define TELOPT_X3PAD	30
#endif
#ifndef TELOPT_NAWS
# define TELOPT_NAWS	31
#endif
#ifndef TELOPT_TSPEED
# define TELOPT_TSPEED	32
#endif
# ifndef TELOPT_LFLOW
#define	TELOPT_LFLOW	33
# endif
#ifndef TELOPT_LINEMODE
# define TELOPT_LINEMODE 34
#endif
#ifndef TELOPT_XDISPLOC
# define TELOPT_XDISPLOC 35
#endif
#ifndef TELOPT_ENVIRON
# define TELOPT_ENVIRON	36
#endif
#ifndef TELOPT_AUTHENTICATION
# define TELOPT_AUTHENTICATION 37
#endif
#ifndef TELOPT_ENCRYPT
# define TELOPT_ENCRYPT	38
#endif
#ifndef TELOPT_EXOPL
# define TELOPT_EXOPL	255
#endif

#ifdef NTELOPTS
# undef NTELOPTS
#endif
#define	NTELOPTS	(1+TELOPT_ENCRYPT)

#ifdef TELOPTS
char *telopts[NTELOPTS+1] = {
	"BINARY", "ECHO", "RCP", "SUPPRESS GO AHEAD", "NAME",
	"STATUS", "TIMING MARK", "RCTE", "NAOL", "NAOP",
	"NAOCRD", "NAOHTS", "NAOHTD", "NAOFFD", "NAOVTS",
	"NAOVTD", "NAOLFD", "EXTEND ASCII", "LOGOUT", "BYTE MACRO",
	"DATA ENTRY TERMINAL", "SUPDUP", "SUPDUP OUTPUT",
	"SEND LOCATION", "TERMINAL TYPE", "END OF RECORD",
	"TACACS UID", "OUTPUT MARKING", "TTYLOC",
	"3270 REGIME", "X.3 PAD", "NAWS", "TSPEED", "LFLOW",
	"LINEMODE", "XDISPLOC", "ENVIRON", "AUTHENTICATION",
	"ENCRYPT",
	0,
};
#define	TELOPT_FIRST	TELOPT_BINARY
#define	TELOPT_LAST	TELOPT_ENCRYPT
#define	TELOPT_OK(x)	((x) <= TELOPT_LAST && (x) >= TELOPT_FIRST)
#define	TELOPT(x)	telopts[(x)-TELOPT_FIRST]
#endif

/* sub-option qualifiers */
#ifndef TELQUAL_IS
# define TELQUAL_IS	0
#endif
#ifndef TELQUAL_SEND
# define TELQUAL_SEND	1
#endif
#ifndef TELQUAL_INFO
# define TELQUAL_INFO	2
#endif
#ifndef TELQUAL_REPLY
# define TELQUAL_REPLY	2
#endif
#ifndef TELQUAL_NAME
# define TELQUAL_NAME	3
#endif

#endif
